Capitalization issue for object names in 118n keys: button_save_object, button_edit_object, and
Category: 118n Estimated time: 0.00 hour
Target version: 5.0.10

Resolution: Fixed Affected version: 5.0.0
Description

Introduced with #34494 for translation :button_save_object the object_name uses label_query with downcase.

In German (and most likely other languages, too) the translation for label_query has to stay with an upper letter. abfrage speichern is
currently generated with downcase, but it should be "Abfrage speichern”

The attached patch removes downcase from :button_save_object.

Related issues:
Related to Redmine - Patch #36905: German translation update for 5.0-stable Closed

Has duplicate Redmine - Defect #38233: Broken spelling in context menus Closed

Associated revisions

Revision 23191 - 2024-11-03 13:42 - Marius BALTEANU

Use .capitalize for button_save_object, button_edit_object, and button_delete_object labels in order to ensure that only the first character is converted
to uppercase and the rest to lowercase (#37072).

Revision 23193 - 2024-11-03 14:17 - Marius BALTEANU
Backports r23191 to 5.1-stable (#37072).

Revision 23194 - 2024-11-03 14:29 - Marius BALTEANU
Merged r23193 from 5.1-stable to 5.0-stable (#37072).

Revision 23195 - 2024-11-03 15:33 - Marius BALTEANU
Reverts bad change (#37072).

Revision 23199 - 2024-11-03 20:22 - Marius BALTEANU
Reverts bad change (#37072).

History

#1 - 2022-05-05 05:22 - Alexander Meindl

Found another problem with the same change for deleting issues. #31278 uses downcase for :label_issue. This cannot be used for German. In
German it has to be Ticket not ticket.

Actually this problem exists with:

e :button_save_object
e :button_edit_object
e :button_delete_object

For each of these labels object_name uses downcase, which makes Redmine looks very strange in German (I'd not say unusable - but very
unprofessional).

If we want to stick with :button_*
and label_Query. But which language need the lower label and which the upper label? Because of this (unsolvable?) question, it would be better to
revert :button_*_object introduction. Maybe switch to buttons with isolated label, as label_save_issue and label_save_query.

object, we need a lower case and an upper case label for all objects. E.g. label_issue and label_lIssue. label_query

*

Please ignore my patch, it would only remove downcase for label_query, which does not solve all problems related to :button_*_object.

2025-08-23 1/3



https://www.redmine.org/issues/34494
https://www.redmine.org/issues/31278

#2 - 2022-05-05 07:48 - Go MAEDA
- Related to Patch #36905: German translation update for 5.0-stable added

#3 - 2022-08-29 09:52 - der glOwn

Is it possible to foresee approximately when these changes will be deployed live here?

#4 - 2023-01-04 06:44 - Alexander Meindl

Is nobody interested to solve this annoying bug? This bug is not even on the roadmap. Easiest solution would be to revert #34494.

#5 - 2023-01-05 09:54 - Pan Tau

We have the same problem.

For English or other languages that do not care about Uppercase the current solution may work,
but all other languages have an problem with this.

Please let the users decide how to write it right

and add for the cases of #34494, #31278 and similar tickets new labels in the "language".yml
und stop the downcasing of labels.

#6 - 2023-01-10 14:48 - Thomas Loéber

- File Do_not_downcase_labels.patch added
| have extended Alexander's patch to include the new downcased labels from Redmine 5.

#7 - 2024-10-20 17:47 - Go MAEDA
- File clipboard-202410210036-19aqv.png added
- File clipboard-202410210041-egrrp.png added

- Target version set to 6.0.0

Sorry for the delay, | have written a new patch to fix this issue.

The new patch still downcases the string but uses the upcase_first method to correctly capitalize only the first letter of the string.
1(:button_save_object, object_name: 1(:label_query) .downcase) .upcase_first

This approach avoids unintended capitalization in the middle of the string in some languages such as English.

| am setting the target version to 6.0.0.

clipboard-202410210036-19aqv.png
clipboard-202410210041-egrrp.png

#8 - 2024-10-20 17:47 - Go MAEDA
- File 37072.patch added

#9 - 2024-10-23 04:23 - Go MAEDA

- Subject changed from button_save_object should not downcase label_query to Capitalization issue for object names in 118n keys:
button_save_object, button_edit_object, and button_delete_object

#10 - 2024-11-03 13:44 - Marius BALTEANU
- Status changed from New to Resolved
- Assignee set to Marius BALTEANU

- Resolution set to Fixed

I've committed a fix with a slight change. I've preferred to use capitalize instead of downcase and upcase_first, please let me if this works for you.

#11 - 2024-11-03 14:02 - Alexander Meindl

Hi Marius,

this looks good for me. With German language there are no problems with your solution.

#12 - 2024-11-03 14:03 - Marius BALTEANU
- Target version changed from 6.0.0 to 5.0.10
Thanks! I'm going to merge this to stable branches.

#13 - 2024-11-03 22:48 - Marius BALTEANU

- Status changed from Resolved to Closed

#14 - 2024-11-15 08:34 - Go MAEDA

- Has duplicate Defect #38233: Broken spelling in context menus

Files

added

remove_downcase_for_button_object_name.patch
Do_not_downcase_labels.patch
clipboard-202410210036-19aqv.png
clipboard-202410210041-egrrp.png

37072.patch
